package ByteCode;

public class Label
{
  private Instruction inst;
  public int offset;

  //
  // ByteCode
  //
  protected Label(int target) {
    inst = null; offset = target;
  }

  protected void Resolve(Instruction ins) {
    inst = ins;
  }

  protected boolean Adjust() {
    if ( offset != inst.offset ) {
      offset = inst.offset;
      return false;
    } else
      return true;
  }

  //
  // CodeModify
  //
  protected Label(Instruction ins) {
    inst = ins;
    offset = ins.offset;
  }

  //
  // utilities
  //
  public Instruction getInst() {
    return inst;
  }
}
