package ByteCode;
import DataFlow.*;

// ATHROW

public class opATHROW extends Instruction
{
  public opATHROW(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    Var v = stat.stack.pop(T_REFER);
    stat.stack.Flash();
    stat.stack.push(v);
    return new NextState(stat);
  }

  public opATHROW(int op) {
    super(op);
    length = 1;
  }
}
