package ByteCode;
import DataFlow.*;

// MONITORENTER,MONITOREXIT

public class opMONITOR extends Instruction
{
  public opMONITOR(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    stat.stack.pop(T_REFER);
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }
}
