package ByteCode;
import DataFlow.*;

// NEW

public class opNEW extends Instruction
{
  int cindex;

  public opNEW(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 3;
    cindex = ReadShort(ofs+1);
  }

  public void Save() {
    super.Save();
    WriteShort(offset+1, cindex);
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    stat.stack.push(bc.getClassVar(cindex));
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opNEW(int op, int cidx) {
    super(op);
    length = 3;
    cindex = cidx;
  }
}
