package ClassFile;
import java.io.*;

public abstract class infoAttribute implements ClassFileConst
{
  public ClassFile   owner;
  public infoCPindex name;
  public int	     length;

  public infoAttribute(ClassFile cf, infoCPindex cp, DataInputStream in) throws Exception {
    owner = cf; name = cp; length = in.readInt(); Load(in);
  }

  abstract public void Load(DataInputStream in) throws Exception;
  abstract public void Adjust();

  public void Save(DataOutputStream out) throws IOException {
    name.Save(out);
    out.writeInt(length);
  }

  static public infoAttribute AutoLoad(ClassFile cf, DataInputStream in) throws Exception {
    infoCPindex name = new infoCPindex(in, cf.constant_pool, CONSTANT_Utf8);
    if ( name.cp.value.equals(ATTR_Code) )
      return new infoAttrCode(cf, name, in);
    else
      return new infoAttrUnknown(cf, name, in);
  }
}
