package DataFlow;
import java.util.*;

public class NextState
{
  public boolean isRET;
  public State except;
  public Stack states;

  public NextState(State ex) {
    except = new State(ex);
    states = new Stack();
  }

  public void push(Flow flow) {
    states.push(flow);
  }

  public Flow pop() {
    return (Flow)states.pop();
  }

  public boolean empty() {
    return states.empty();
  }
}
