package ByteCode;
import DataFlow.*;

// ARRAYLENGTH

public class opARRAYLENGTH extends Instruction
{
  public opARRAYLENGTH(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    if ( !stat.stack.pop().isArray() )
      throw new DataFlowException("opARRAYLENGTH", strType);
    stat.stack.push(Var.vint);
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }
}
