package ByteCode;
import DataFlow.*;

// INSTANCEOF

public class opINSTANCEOF extends Instruction
{
  int cindex;

  public opINSTANCEOF(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 3;
    cindex = ReadShort(ofs+1);
  }

  public void Save() {
    super.Save();
    WriteShort(offset+1, cindex);
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    stat.stack.pop(T_REFER);
    stat.stack.push(Var.vint);
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }
}
