package ByteCode;
import DataFlow.*;

// NOP

public class opNOP extends Instruction
{
  public opNOP(ByteCode bc, int ofs) {
    super(bc, ofs);
    length = 1;
  }

  public NextState Analyze(State stat) throws DataFlowException {
    if ( SaveState(stat) )
      return null;
    NextState ns = new NextState(stat);
    ns.push(new Flow(bc.NextInst(this), stat));
    return ns;
  }

  public opNOP(int op) {
    super(op);
    length = 1;
  }
}
