package ClassFile;
import java.io.*;

public class infoMethod implements ClassFileConst
{
  public ClassFile	owner;
  public int		flag;
  public infoCPindex	name;
  public infoCPindex	desc;
  public infoAttribute	attrs[];

  public infoMethod(ClassFile cf, DataInputStream in) throws Exception {
    owner = cf; Load(in);
  }

  public void Load(DataInputStream in) throws Exception {
    flag = in.readUnsignedShort();
    name = new infoCPindex(in, owner.constant_pool, CONSTANT_Utf8);
    desc = new infoCPindex(in, owner.constant_pool, CONSTANT_Utf8);
    attrs = new infoAttribute[in.readUnsignedShort()];
    for (int i = 0; i < attrs.length; i++)
      attrs[i] = infoAttribute.AutoLoad(owner, in);
  }

  public void Save(DataOutputStream out) throws IOException {
    out.writeShort(flag);
    name.Save(out);
    desc.Save(out);
    out.writeShort(attrs.length);
    for (int i = 0; i < attrs.length; i++)
      attrs[i].Save(out);
  }

  public infoAttrCode getAttrCode() throws ClassFileException {
    for (int i = 0; i < attrs.length; i++)
      if ( attrs[i] instanceof infoAttrCode )
	return (infoAttrCode)attrs[i];
    throw new ClassFileException("infoMehtod.GetAttrCode", "attribute Code not found");
  }
}
